oUF.colors.power[0].r = 0.0
oUF.colors.power[0].g = 0.8
oUF.colors.power[0].b = 1.0

local dummy, pClass = UnitClass('player')

local LibMobHealth = LibStub("LibMobHealth-4.0")

--Right Click menus

local function menu(self)
	local unit = self.unit:sub(1, -2)
	local cunit = self.unit:gsub('(.)', string.upper, 1)

	if(unit == 'party' or unit == 'partypet') then
		ToggleDropDownMenu(1, nil, _G['PartyMemberFrame'..self.id..'DropDown'], 'cursor', 0, 0)
	elseif(_G[cunit..'FrameDropDown']) then
		ToggleDropDownMenu(1, nil, _G[cunit..'FrameDropDown'], 'cursor', 0, 0)
	end
end


local select = select
local UnitClass = UnitClass
local UnitIsDead = UnitIsDead
local UnitIsGhost = UnitIsGhost
local UnitIsConnected = UnitIsConnected
local RAID_CLASS_COLORS = RAID_CLASS_COLORS

local texturebar = "Interface\\AddOns\\oUF_Kera\\statusbar"
local fontnormal = "Interface\\AddOns\\oUF_Kera\\font.ttf"

local classification = {
	worldboss = 'Boss',
	rareelite = '%s+ Rare',
	elite = '%s+',
	rare = '%s Rare',
	normal = '%s',
	trivial = '%s',
}

--Unit colors: Class(Player), Happiness(Pet), Reaction(NPC)

local function updateColor(self, element, unit, func)
	local color
	local dummy, rClass = UnitClass(unit)
	if(UnitIsTapped(unit) and not UnitIsTappedByPlayer(unit) or not UnitIsConnected(unit)) then
		color = self.colors.health[1]
	elseif(unit == 'pet') then
		color = self.colors.happiness[GetPetHappiness()] or self.colors.power[UnitPowerType(unit)]
	elseif(UnitIsPlayer(unit)) then
		color = RAID_CLASS_COLORS[rClass]
	else
		color = UnitReactionColor[UnitReaction(unit, 'player')] or self.colors.health[1]
	end

	if(color) then
		if(func == 'SetVertexColor') then
			element[func](element, color.r * 0.3, color.g * 0.3, color.b * 0.3)
		else
			element[func](element, color.r, color.g, color.b)
		end
	end
end

--Name

local function updateName(self, event, unit)
	if(self.unit == unit) then
			self.Name:SetTextColor(1.0, 1.0, 1.0)
		if(unit == 'target') then
			self.Name:SetFormattedText(UnitName(unit))
		else
			self.Name:SetText(UnitName(unit))
		end
	end
end

local function updateHappiness(self, event, unit)
	updateColor(self, self.Power, unit, 'SetStatusBarColor')
end

--Health Bar & Values + LibMobHealth support

local updateHealth = function(self, event, bar, unit, min, max)
	if(UnitIsDead(unit)) then
		bar:SetValue(0)
		bar.value:SetText("Dead")
	elseif(UnitIsGhost(unit)) then
		bar:SetValue(0)
		bar.value:SetText("Ghost")
	elseif(not UnitIsConnected(unit)) then
		bar.value:SetText("Offline")
	else
		if(unit=="player") then
			if(min~=max) then
				bar.value:SetText(min)
			else
				bar.value:SetText(max)
			end
		elseif(self:GetParent():GetName()=="oUF_Party" or self:GetParent():GetName():sub(1,8)=="oUF_Raid") then -- not unit
			if(min~=max) then
				bar.value:SetText(min-max)
			else
				bar.value:SetText()
			end
		else
			if(max==100) then
				if(unit=="target" and not UnitIsPlayer("target")) then
					local cur, maxhp = LibMobHealth:GetUnitHealth(unit)
					bar.value:SetText(cur)
				else
					bar.value:SetText(min)
				end
			else
				bar.value:SetText(min)
			end
		end
	end

	if(UnitIsTapped(unit) and not UnitIsTappedByPlayer(unit) or not UnitIsConnected(unit)) then
		self.Power:SetStatusBarColor(0.6, 0.6, 0.6)
	else
		self:UNIT_NAME_UPDATE(event, unit)
	end
end

--Power Bar, Values(Player only) & Coloring

local function updatePower(self, event, bar, unit, min, max)
	updateColor(self, bar, unit, 'SetStatusBarColor')
	updateColor(self, bar.bg, unit, 'SetVertexColor')

	if(not bar.value) then return end
	if(not UnitIsPlayer(unit)) then
		bar.value:SetText()
	else
		if(min == 0) then
			bar.value:SetText()
		elseif(UnitIsDead(unit) or UnitIsGhost(unit)) then
			bar:SetValue(0)
		elseif(not UnitIsConnected(unit)) then
			bar.value:SetText()
		else
			bar.value:SetTextColor(1.0, 1.0, 1.0)
			if(unit ~= 'player') then
				
				if(min ~= max) then
					bar.value:SetFormattedText(max-(max-min))
				else
					bar.value:SetFormattedText(min)
				end
			else
				if(min ~= max) then
					bar.value:SetText(max-(max-min))
				else
					bar.value:SetText(min)
				end
			end
		end
	end
end

--Raid Health deficit

local updateRaidHealth = function(self, event, bar, unit, min, max)
	if(UnitIsDead(unit)) then
		bar:SetValue(0)
		bar.value:SetText("Dead")
	elseif(UnitIsGhost(unit)) then
		bar:SetValue(0)
		bar.value:SetText("Ghost")
	elseif(not UnitIsConnected(unit)) then
		bar.value:SetText("Off")
	else
		if(min~=max) then
			bar.value:SetText(min-max)
		else
			bar.value:SetText()
		end
	end

	local color = RAID_CLASS_COLORS[select(2, UnitClass(unit))]
	if(color) then bar:SetStatusBarColor(color.r, color.g, color.b) end
end

--Font

local setFontString = function(parent, fontStyle, fontHeight)
	local fs = parent:CreateFontString(nil, "OVERLAY")
	fs:SetFont(fontStyle, fontHeight)
	fs:SetShadowColor(0,0,0)
	fs:SetShadowOffset(0.8, -0.8)
	fs:SetTextColor(1,1,1)
	fs:SetJustifyH("LEFT")
	return fs
end

--Raid frames (taken from an older version of oUF P3lim)

local backdrop = {
	bgFile = "Interface\\Tooltips\\UI-Tooltip-Background",
	insets = {left = -0.9, right = -0.9, top = -0.9, bottom = -0.9},
}

local setRaidStyle = function(settings, self, unit)
	self:SetScript("OnEnter", UnitFrame_OnEnter)
	self:SetScript("OnLeave", UnitFrame_OnLeave)

	self:SetBackdrop(backdrop)
	self:SetBackdropColor(0,0,0,1)
	
	local hp = CreateFrame("StatusBar", nil, self)
	hp:SetHeight(19)
	hp:SetWidth(42)
	hp:SetStatusBarTexture(texturebar)
	hp:SetPoint("CENTER")

	hp.bg = hp:CreateTexture(nil, "BORDER")
	hp.bg:SetAllPoints(hp)
	hp.bg:SetTexture(.25,.25,.25)

	hp.value = setFontString(hp, fontnormal, 12)
	hp.value:SetPoint("RIGHT", -2, -1)

	self.Health = hp
	self.OverrideUpdateHealth = updateRaidHealth

	local icon = hp:CreateTexture(nil, "OVERLAY")
	icon:SetHeight(13)
	icon:SetWidth(13)
	icon:SetPoint("TOP", self, -13, -3)
	icon:SetTexture("Interface\\TargetingFrame\\UI-RaidTargetingIcons")
	self.RaidIcon = icon

	local leader = hp:CreateTexture(nil, "OVERLAY")
	leader:SetHeight(16)
	leader:SetWidth(16)
	leader:SetPoint("TOPLEFT", self, 0, 8)
	leader:SetTexture("Interface\\GroupFrame\\UI-Group-LeaderIcon")
	leader:SetAlpha(0)
	self.Leader = leader

	local check = hp:CreateTexture(nil, "OVERLAY") -- oUF_ReadyCheck support on raid
	check:SetWidth(16)
	check:SetHeight(16)
	check:SetPoint("TOPLEFT", self, "BOTTOMRIGHT", -8, 8)
	check:Hide()
	self.ReadyCheck = check

	local voice = hp:CreateTexture(nil, "OVERLAY") -- oUF_Voice support on raid
	voice:SetWidth(16)
	voice:SetHeight(16)
	voice:SetPoint("BOTTOMLEFT", self, "TOPRIGHT", -8, -8)
	voice:Hide()
	self.Voice = voice

	local dbh = hp:CreateTexture(nil, "OVERLAY") -- oUF_DebuffHighlight, grid style debuffs on raid
	dbh:SetHeight(10)
	dbh:SetWidth(10)
	dbh:SetPoint("CENTER", hp)
	dbh:SetTexture("Interface\\Tooltips\\UI-Tooltip-Background")
	dbh:SetBlendMode("ADD")
	dbh:SetVertexColor(0,0,0,0)
	self.DebuffHighlight = dbh
	self.DebuffHighlightAlpha = 1
	self.DebuffHighlightFilter = true

	self.Range = true
	self.inRangeAlpha = 1
	self.outsideRangeAlpha = .3

	return self
end

--Buff & Debuff texture

local function auraIcon(self, button, icons, index, debuff)
	button.cd:SetReverse()
	button.icon:SetTexCoord(0.07, 0.93, 0.07, 0.93)
	button.overlay:SetTexture('Interface\\AddOns\\oUF_Kera\\border')
	button.overlay:SetTexCoord(0.0, 1.0, 0.0, 1.0)
	button.overlay.Hide = function(self) self:SetVertexColor(0.25, 0.25, 0.25) end
end

--Non-Raid Frames

local function style(settings, self, unit)
	self.menu = menu
	self:RegisterForClicks('AnyUp')
	self:SetAttribute('*type2', 'menu')
	self:SetScript('OnEnter', UnitFrame_OnEnter)
	self:SetScript('OnLeave', UnitFrame_OnLeave)

	self:SetBackdrop({bgFile = 'Interface\\ChatFrame\\ChatFrameBackground', insets = {top = -1, left = -1, bottom = -1, right = -1}})
	self:SetBackdropColor(0.0, 0.0, 0.0, 1.0)

	self.Health = CreateFrame('StatusBar', nil, self)
	self.Health:SetStatusBarTexture('Interface\\AddOns\\oUF_Kera\\statusbar')
	self.Health:SetStatusBarColor(0.25, 0.25, 0.25)
	self.Health:SetHeight(unit and 20 or 16)
	self.Health:SetPoint('TOPLEFT')
	self.Health:SetPoint('TOPRIGHT')

	self.Health.bg = self.Health:CreateTexture(nil, 'BORDER')
	self.Health.bg:SetAllPoints(self.Health)
	self.Health.bg:SetTexture(0.14, 0.14, 0.14)

	self.Health.value = self.Health:CreateFontString(nil, 'OVERLAY')
	self.Health.value:SetFontObject(GameFontNormalSmall)
	self.Health.value:SetPoint('RIGHT', -2, -1)
	self.Health.value:SetTextColor(1, 1, 1)
	self.Health.value:SetJustifyH('RIGHT')

	self.Power = CreateFrame('StatusBar', nil, self)
	self.Power:SetStatusBarTexture('Interface\\AddOns\\oUF_Kera\\statusbar')
	self.Power:SetHeight(unit and 4 or 3)
	self.Power:SetPoint('TOPLEFT', self.Health, 'BOTTOMLEFT', 0, -1)
	self.Power:SetPoint('TOPRIGHT', self.Health, 'BOTTOMRIGHT', 0, -1)

	self.Power.bg = self.Power:CreateTexture(nil, 'BACKGROUND')
	self.Power.bg:SetAllPoints(self.Power)
	self.Power.bg:SetTexture('Interface\\ChatFrame\\ChatFrameBackground')

	self.Power.value = self.Health:CreateFontString(nil, 'OVERLAY')
	self.Power.value:SetFontObject(GameFontNormalSmall)
	self.Power.value:SetPoint('LEFT', 2, -1)
	self.Power.value:SetTextColor(1, 1, 1)

	self.Leader = self.Health:CreateTexture(nil, 'OVERLAY')
	self.Leader:SetHeight(16)
	self.Leader:SetWidth(16)
	self.Leader:SetPoint('TOPLEFT', self, 0, 8)
	self.Leader:SetTexture('Interface\\GroupFrame\\UI-Group-LeaderIcon')
	self.Leader:SetAlpha(0)

	self.RaidIcon = self.Health:CreateTexture(nil, 'OVERLAY')
	self.RaidIcon:SetHeight(16)
	self.RaidIcon:SetWidth(16)
	self.RaidIcon:SetPoint('TOP', self, 0, -1)
	self.RaidIcon:SetTexture('Interface\\TargetingFrame\\UI-RaidTargetingIcons')

	self.Name = self.Health:CreateFontString(nil, 'OVERLAY')
	self.Name:SetFontObject(GameFontNormalSmall)
	self.Name:SetPoint('LEFT', 2, -1)
	self.Name:SetTextColor(1, 1, 1)

	if(unit == 'player') then
		self.Spark = self.Power:CreateTexture(nil, 'OVERLAY')
		self.Spark:SetTexture('Interface\\CastingBar\\UI-CastingBar-Spark')
		self.Spark:SetBlendMode('ADD')
		self.Spark:SetHeight(8)
		self.Spark:SetWidth(8)
		self.Spark.manatick = true

		self.Name:Hide()

		if(class == 'DRUID') then
			self.DruidManaBar = CreateFrame('StatusBar', nil, self)
			self.DruidManaBar:SetHeight(1)
			self.DruidManaBar:SetStatusBarTexture('Interface\\AddOns\\oUF_Kera\\statusbar')
			self.DruidManaBar:SetPoint('BOTTOMRIGHT', self.Power, 'TOPRIGHT')
			self.DruidManaBar:SetPoint('BOTTOMLEFT', self.Power, 'TOPLEFT')

			self.DruidManaText = self.DruidManaBar:CreateFontString(nil, 'OVERLAY')
			self.DruidManaText:SetFontObject(GameFontNormalSmall)
			self.DruidManaText:SetPoint('CENTER')
		end
	end

	if(unit == 'target') then
		if(pClass == 'ROGUE' or pClass == 'DRUID') then
			self.CPoints = self:CreateFontString(nil, 'OVERLAY')
			self.CPoints:SetPoint('RIGHT', self, 'LEFT', -9, 0)
			self.CPoints:SetFontObject(SubZoneTextFont)
			self.CPoints:SetTextColor(1, 1, 1)
			self.CPoints:SetJustifyH('RIGHT')
		end

		self.Power.value:Hide()

		self.Buffs = CreateFrame('Frame', nil, self)
		self.Buffs:SetPoint('TOPLEFT', self, 'TOPRIGHT', 3, 1)
		self.Buffs:SetHeight(24 * 2)
		self.Buffs:SetWidth(170)
		self.Buffs.num = 24
		self.Buffs.size = 27
		self.Buffs.spacing = 2
		self.Buffs.initialAnchor = 'TOPLEFT'
		self.Buffs['growth-y'] = 'DOWN'

		self.Debuffs = CreateFrame('Frame', nil, self)
		self.Debuffs:SetPoint('TOPLEFT', self, 'BOTTOMLEFT', -1, -3)
		self.Debuffs:SetHeight(22)
		self.Debuffs:SetWidth(270)
		self.Debuffs.num = 40
		self.Debuffs.size = 26
		self.Debuffs.spacing = 1.8
		self.Debuffs.initialAnchor = 'TOPLEFT'
		self.Debuffs.showDebuffType = true
		self.Debuffs['growth-y'] = 'DOWN'
	end

	if(unit == 'pet' and pClass == 'HUNTER') then
		self.UNIT_HAPPINESS = updateHappiness
		self:RegisterEvent('UNIT_HAPPINESS')
	end

	if(settings.pettot) then
		self.Health:SetHeight(19)
		self.Health.value:SetPoint('RIGHT', -2, 0)
		self.Power.value:Hide()
		self.Power:SetHeight(2)

		self.Debuffs = CreateFrame('Frame', nil, self)
		self.Debuffs:SetHeight(23)
		self.Debuffs:SetWidth(180)
		self.Debuffs.size = 25 * 0.97
		self.Debuffs.spacing = 1.8
		self.Debuffs.showDebuffType = true
		self.Debuffs.num = 4

		if(unit == 'pet') then
			self.Debuffs:SetPoint('TOPLEFT', self, 'TOPRIGHT', 3, 1)
			self.Debuffs.initialAnchor = 'TOPLEFT'
		elseif(unit == 'targettarget') then
			self.Debuffs:SetPoint('TOPRIGHT', self, 'TOPLEFT', -3, 1)
			self.Debuffs.initialAnchor = 'TOPRIGHT'
			self.Debuffs['growth-x'] = 'LEFT'
		end
	end

	if(not unit) then
		self.Power.value:Hide()
		self.outsideRangeAlpha = 0.4
		self.inRangeAlpha = 1.0
		self.Range = true
	end

	self.UNIT_NAME_UPDATE = updateName
	self.PostCreateAuraIcon = auraIcon
	self.OverrideUpdatePower = updatePower
	self.OverrideUpdateHealth = updateHealth

	return self
end

--Frame sizes

oUF:RegisterSubTypeMapping('UNIT_LEVEL')
oUF:RegisterStyle('Kera', setmetatable({
	['initial-width'] = 274,
	['initial-height'] = 25,
}, {__call = style }))
oUF:RegisterStyle('KeraFocus', setmetatable({
	['initial-width'] = 150,
	['initial-height'] = 25,
}, {__call = style }))
oUF:RegisterStyle('KeraPeToT', setmetatable({
	['initial-width'] = 170,
	['initial-height'] = 22,
	['pettot'] = true,
}, {__call = style }))
oUF:RegisterStyle('KeraParty', setmetatable({
	['initial-width'] = 120,
	['initial-height'] = 20,
}, {__call = style }))
oUF:RegisterStyle("Kera_Raid", setmetatable({
	["initial-width"] = 42,
	["initial-height"] = 19,
}, {__call = setRaidStyle}))

oUF:SetActiveStyle('Kera')
oUF:Spawn('player'):SetPoint('CENTER', UIParent, -290, -250)
oUF:Spawn('target'):SetPoint('CENTER', UIParent, 290, -250)

oUF:SetActiveStyle('KeraFocus')
oUF:Spawn('focus'):SetPoint('RIGHT', oUF.units.player, 'LEFT', -5, 0)

oUF:SetActiveStyle('KeraPeToT')
oUF:Spawn('targettarget'):SetPoint('BOTTOMRIGHT', oUF.units.target, 'TOPRIGHT', 0, 5)
oUF:Spawn('pet'):SetPoint('BOTTOMLEFT', oUF.units.player, 'TOPLEFT', 0, 5)

oUF:SetActiveStyle('KeraParty')
local party = oUF:Spawn('header', 'oUF_Party')
party:SetPoint('TOPLEFT', UIParent, 5, -25)
party:SetManyAttributes('yOffset', -5, 'showParty', true, 'showPlayer', true)

oUF:SetActiveStyle("Kera_Raid")
local last = {}
for i = 1, 8 do
	local raid = oUF:Spawn("header", "oUF_Raid"..i)
	raid:SetManyAttributes("groupFilter", tostring(i), "showRaid", true, "yOffSet", -8)
	table.insert(last, raid)
	if(i==1) then
		raid:SetPoint("TOPLEFT", UIParent, "TOPLEFT", 5, -25)
	else
		raid:SetPoint("TOPLEFT", last[i-1], "TOPRIGHT", 8, 0)
	end
	raid:Show()
end

local partyToggle = CreateFrame('Frame')
partyToggle:RegisterEvent('PLAYER_LOGIN')
partyToggle:RegisterEvent('RAID_ROSTER_UPDATE')
partyToggle:RegisterEvent('PARTY_LEADER_CHANGED')
partyToggle:RegisterEvent('PARTY_MEMBER_CHANGED')
partyToggle:SetScript('OnEvent', function(self)
	if(InCombatLockdown()) then
		self:RegisterEvent('PLAYER_REGEN_ENABLED')
	else
		self:UnregisterEvent('PLAYER_REGEN_DISABLED')
		if(HIDE_PARTY_INTERFACE == '1' and GetNumRaidMembers() > 0) then
			party:Hide()
		else
			party:Show()
		end
	end
end)